qwt_math.h(3)

NAME
qwt_math.h -

Detailed Description

A set of mathematical routines.

Definition in file qwt_math.h.

SYNOPSIS

  Defines
#define LOG10_2 0.30102999566398119802
#define LOG10_3 0.47712125471966243540
#define LOG10_5 0.69897000433601885749
#define M_2PI 6.28318530717958623200
#define LOG_MIN 1.0e-100
#define LOG_MAX 1.0e100
#define M_E 2.7182818284590452354
#define M_LOG2E 1.4426950408889634074
#define M_LN2 0.69314718055994530942
#define M_LN10 2.30258509299404568402
#define M_PI 3.14159265358979323846
#define M_PI_2 1.57079632679489661923
#define M_PI_4 0.78539816339744830962
#define M_1_PI 0.31830988618379067154
#define M_2_PI 0.63661977236758134308
#define M_2_SQRTPI 1.12837916709551257390
#define M_SQRT2 1.41421356237309504880
#define M_SQRT1_2 0.70710678118654752440
#define qwtMax QMAX
#define qwtMin QMIN
#define qwtAbs QABS
#define qwtInt qRound

  Functions
QWT_EXPORT double qwtCeil125 (double x)
QWT_EXPORT double qwtFloor125 (double x)
QWT_EXPORT double qwtGetMin (double *array, int size)
QWT_EXPORT double qwtGetMax (double *array, int size)
QWT_EXPORT void qwtTwistArray (double *array, int size)
QWT_EXPORT int qwtChkMono (double *array, int size)
QWT_EXPORT void qwtLinSpace (double *array, int size, double xmin, double xmax)
QWT_EXPORT void qwtLogSpace (double *array, int size, double xmin, double xmax)
template<class T> int qwtSign (const T &x)
template<class T> T qwtSqr (const T &x)
template<class T> void qwtCopyArray (T *dest, T *src, int n)
template<class T> void qwtShiftArray (T *arr, int size, int di)
template<class T> void qwtSwap (T &x1, T &x2)
template<class T> void qwtSort (const T &x1, const T &x2, T &xmin, T &xmax)
template<class T> void qwtSort (T &x1, T &x2)
template<class T> T qwtLim (const T &x, const T &x1, const T &x2)
QPoint qwtPolar2Pos (const QPoint &center, double radius, double angle)
QPoint qwtDegree2Pos (const QPoint &center, double radius, double angle)

Define Documentation

  #define LOG_MAX 1.0e100

Maximum value for logarithmic scales.

Definition at line 46 of file qwt_math.h.

Referenced by QwtAutoScale::setRange(), and QwtAutoScale::setReference().

  #define LOG_MIN 1.0e-100

Mininum value for logarithmic scales.

Definition at line 41 of file qwt_math.h.

Referenced by QwtAutoScale::setRange(), and QwtAutoScale::setReference().

Function Documentation

  QWT_EXPORT double qwtCeil125 (double x)

Find the smallest value out of {1,2,5}*10^n with an integer number n which is greater than or equal to x.

Parameters:
    x Input value

Definition at line 56 of file qwt_math.cpp.

  QWT_EXPORT int qwtChkMono (double * array, int size)

Checks if an array is a strictly monotonic sequence.

Parameters:
    array Pointer to an array
    size Size of the array

Returns:

    0   sequence is not strictly monotonic

    1   sequence is strictly monotonically increasing

    -1  sequence is strictly monotonically decreasing

Definition at line 119 of file qwt_math.cpp.

  template<class T> void qwtCopyArray (T * dest, T * src, int n)

Copy an array into another.

Parameters:
    dest Destination
    src Source
    n Number of elements

Definition at line 142 of file qwt_math.h.

Referenced by qwtShiftArray().

  QWT_EXPORT double qwtFloor125 (double x)

Find the largest value out of {1,2,5}*10^n with an integer number n which is smaller than or equal to x.

Parameters:
    x Input value

Definition at line 85 of file qwt_math.cpp.

  QWT_EXPORT double qwtGetMax (double * array, int size)

Find the largest value in an array.

Parameters:
    array Pointer to an array
    size Array size

Definition at line 37 of file qwt_math.cpp.

  QWT_EXPORT double qwtGetMin (double * array, int size)

Find the smallest value in an array.

Parameters:
    array Pointer to an array
    size Array size

Definition at line 19 of file qwt_math.cpp.

  template<class T> T qwtLim (const T & x, const T & x1, const T & x2)

Limit a value to fit into a specified interval.

Parameters:
    x Input value
    x1 First interval boundary
    x2 Second interval boundary

Definition at line 245 of file qwt_math.h.

Referenced by QwtArrowButton::QwtArrowButton(), QwtScaleDraw::setAngleRange(), QwtDblRange::setRange(), QwtWheel::setTickCnt(), QwtWheel::setTotalAngle(), QwtWheel::setViewAngle(), and QwtCurve::verifyRange().

  QWT_EXPORT void qwtLinSpace (double * array, int size, double xmin, double xmax)

Create an array of equally spaced values.

Parameters:
    array Where to put the values
    size Size of the array
    xmin Value associated with index 0
    xmax Value associated with index (size-1)

Definition at line 161 of file qwt_math.cpp.

  QWT_EXPORT void qwtLogSpace (double * array, int size, double xmin, double xmax)

Create an array of logarithmically equally spaced values.

Parameters:
    array Where to put the values
    size Size of the array
    xmin Value associated with index 0
    xmax Value associated with index (size-1)

Definition at line 189 of file qwt_math.cpp.

  template<class T> void qwtShiftArray (T * arr, int size, int di)

Shift an array by a specified number of positions.

Parameters:
    arr Pointer to an array
    size Number of elements
    di Number of positions. A positive number shifts right, a negative number shifts left.

Definition at line 157 of file qwt_math.h.

References qwtCopyArray().

  template<class T> int qwtSign (const T & x)

Return the sign.

Definition at line 118 of file qwt_math.h.

  template<class T> void qwtSort (T & x1, T & x2)

Sort two values in ascending order.

Definition at line 226 of file qwt_math.h.

Referenced by QwtCurve::verifyRange().

  template<class T> void qwtSort (const T & x1, const T & x2, T & xmin, T & xmax)

Sort two values in ascending order.

Parameters:
    x1 First input value
    x2 Second input value
    xmax Greater value
    xmin Smaller value

Definition at line 207 of file qwt_math.h.

  template<class T> T qwtSqr (const T & x)

Return the square of a number.

Definition at line 130 of file qwt_math.h.

Referenced by QwtPlot::closestCurve(), QwtPlot::closestMarker(), and QwtCurve::drawSpline().

  template<class T> void qwtSwap (T & x1, T & x2)

Swap two values.

Definition at line 190 of file qwt_math.h.

  QWT_EXPORT void qwtTwistArray (double * array, int size)

Invert the order of array elements.

Parameters:
    array Pointer to an array
    size Size of the array

Definition at line 141 of file qwt_math.cpp.

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.